#
# $Id: Ci.rb,v 1.148 2004/01/13 14:16:15 Yuukis Exp $
#
CiVersion = 'delta.3'
CiCode = 'Fantastic Powers'
CiString = "C.i. - Compact Interface for 2ch. version #{CiVersion} (#{CiCode})"
CiShortString = "C.i. (version: #{CiVersion})"
CiTitleString = "C.i. for 2ch. version #{CiVersion} (#{CiCode})"

$KCODE = 'e'
Thread::abort_on_exception = true

#

if $0 != __FILE__  # required spin up

	require 'ci/appcfg'
	CFG.init('ci', 'C.i.')
	require 'ci/sitecfg'
	
	require 'ci/nls'
	require 'ci/httpext'
	require 'ci/bbsinit'
	BBSMenu.get if CFG::Net.bbsmenu_check
	BBSMenu.init
	
	require 'ci/util2ch'
	require 'ci/stdext'
	require 'ci/migemoext'
	require 'ci/bbsboard'
	require 'ci/bbspost'
	require 'ci/bbsthread'
	
	require 'gtk'
	require 'ci/gtkext'
	require 'ci/gtkmisc'
	require 'ci/gtkboards'
	require 'ci/gtkboard'
	require 'ci/gtkpost'
	require 'ci/gtkthread'
	require 'ci/gtkcfg'
	CFG.gui_init
	
	require 'ci/session'

else  # direct spin up

	load 'appcfg.rb'
	CFG.init('ci', 'C.i.')
	
	load 'nls.rb'
	load 'httpext.rb'
	load 'bbsinit.rb'
	BBSMenu.get if CFG::Net.bbsmenu_check
	BBSMenu.init
	
	load 'util2ch.rb'
	load 'stdext.rb'
	load 'migemoext.rb'
	load 'bbsboard.rb'
	load 'bbspost.rb'
	load 'bbsthread.rb'
	
	require 'gtk'
	load 'gtkext.rb'
	load 'gtkmisc.rb'
	load 'gtkboards.rb'
	load 'gtkboard.rb'
	load 'gtkpost.rb'
	load 'gtkthread.rb'
	load 'gtkcfg.rb'
	CFG.gui_init
	
	load 'session.rb'

end
	
#

cls =  "#{CiString}\n\n"
cls << " Ruby: #{RUBY_VERSION} (#{RUBY_RELEASE_DATE})\n"
cls << " Gtk+: #{Gtk::VERSION[0]}.#{Gtk::VERSION[1]}.#{Gtk::VERSION[2]}\n"
cls << " Ruby/Gtk+: #{Gtk::BINDING_VERSION[0]}.#{Gtk::BINDING_VERSION[1]}#{Gtk::BINDING_VERSION[2]}\n"
cls << " PlatForm: #{RUBY_PLATFORM}\n"
case MigemoExt::TYPE
when 'Ruby' then cls << "  [ with #{MigemoExt::TYPE}/Migemo #{MigemoExt::VERSION} ]\n"
when 'C'    then cls << "  [ with #{MigemoExt::TYPE}/Migemo ]\n"
end

CiLongString = cls

#

class Ci < Gtk::Window

	#
	# init & quit
	#

	def initialize

		gtkrc = CFG::SYS.root + 'gtkrc'
		Gtk::RC.parse(gtkrc) if File.exist?(gtkrc)

		@tab_lock = Status.new
		@thread_chain = {}
		@switch = false
		@s_thr = Thread.fork { Thread.exit }  # thread for subject get.
		@t_thr = Thread.fork { Thread.exit }  # thread for thread get.

		super()
		realize
	end

	def init
		case ARGV[0]
		when '-v'
			puts CiLongString
			exit
		when '-g'
			CFG::Net.bbsmenu_chack = true
		when '-d'
			Logger.init(CiString)
			Logger.write(__FILE__, __LINE__, '$DEBUG = true')
			$DEBUG = true
		end

		puts CFG::NLS.ruby_too_old if RUBY_VERSION < '1.6.4'

		top_handle = Gtk::HandleBox.new.add top_buttons
		favorites_handle = Gtk::HandleBox.new.add favorites_buttons

		main = Gtk::VBox.new
		main.pack_start top_handle, false
		main.pack_start main_pane
		main.pack_start favorites_handle, false

		add main

		set_default_size(CFG::UIF.width, CFG::UIF.height)
		set_title(CiTitleString)
		signal_connect('delete_event') { quit ; Gtk::main_quit }
		signal_connect('size_allocate') { size_allocate }

		session_start
	end

	def session_start
		profile = Session::Profile.read(CFG::SYS.root + 'profile')
		if profile and profile.include?('origin')
			x = profile['origin'].split(':')
			set_uposition(x[0].to_i, x[1].to_i)
		end

		show_all

		@top.check.active = true if profile and profile.include?('tab_lock')

		Thread.fork {
			@top.windmill.start('Session:0')
			session = Session.read("#{CFG::SYS.root}session")
			if session
				session.each {|board, type, dat, title|
					open_text_frame(board, dat, type, false)
					while true
						sleep Session::SLEEP_TIME
						break unless @top.windmill.q.include?('G:'.concat(dat))
					end
				}
			end
			@top.windmill.stop('Session:0')
		}

		# @top.urlview.set_text(' Where is My Silver Bullet ?')
		# @top.urlview.set_text(' How many files(0-15) ?')
		# @top.urlview.set_text(' MEMORY 640KB + 13312KB OK')
		# @top.urlview.entry.set_text(' Welcome to C.i. World !!')
		@top.urlview.entry.set_text(CFG::NLS.greeting)

		set_focus(@subjects.child)	
	end

	def quit
		session = []
		@main_note.set_page(0)
		@main_note.next_page
		while @main_note.get_current_page != 0
			cur = @main_note.cur_page.child
			cur.vadj_info.write
			session << [cur.board, cur.class.to_s[0, 4].downcase, cur.dat, cur.title]
			@thread_chain.delete(cur.dat)
			@main_note.remove_page(@main_note.get_current_page)
			@main_note.next_page
		end
		Session.write("#{CFG::SYS.root}session", session)

		x, y = window.get_root_origin
		profile = { \
			'board' => @main_note.cur_page.child.board,
			'origin' => x.to_s + ':' + y.to_s
			}
		profile['tab_lock']= @tab_lock.active?.to_s if @tab_lock.active?
		Session::Profile.write(CFG::SYS.root + 'profile', profile)
	end


	#
	# widgets
	#

	def top_buttons
		@top = GtkExt::TopButtons.new

		@top.select.signal_connect('clicked') {
			if @top.select.active?
				@main_pane.set_position(CFG::UIF.bs_active) 
				@main_pane.set_gutter_size(CFG::UIF.boardselect_border + 2)
				@main_pane.set_handle_size(CFG::UIF.boardselect_border)
				set_focus(@board_tree.child)
			else
				@main_pane.set_position(CFG::UIF.bs_nonactive)
				@main_pane.set_gutter_size(0)
				@main_pane.set_handle_size(0)
				set_focus(@main_note.cur_page.child.child)
			end
		}

		@top.bookmark.signal_connect('clicked') {
			@subjects.filter.bookmark = @top.bookmark.active
			@subjects.update(false)
		}

		@top.reload.signal_connect('clicked') {
			cur = @main_note.cur_page.child
			case cur.class.to_s
			when 'SubjectFrame'
				@s_thr = Thread.fork {
					w = @top.windmill.start('U:Subject')
					if w
						cur.update
						@top.windmill.stop('U:Subject')
					end
				}
			else
				@t_thr = Thread.fork {
					w = @top.windmill.start('U:'.concat(cur.dat))
					if w
						cur.update
						@top.windmill.stop('U:'.concat(cur.dat))
					end
				}
			end
			set_focus(@main_note.cur_page.child.child)
		}

		@top.cancel.signal_connect('clicked') {
			@s_thr.kill if @s_thr.alive? ; @subjects.rollback
			@t_thr.kill if @t_thr.alive? ; @top.windmill.kill
		}

		@top.find.signal_connect('clicked') {
			@switch = true  # not yet. äƤ ... ʤޤ󥹥ȤǤ뤳ȤϳΤ
				@top.urlview.add_str(@main_note.cur_page.child.board, @top.urlview.entry.get_text)
			@switch = false
			@main_note.cur_page.child.find(@top.urlview.entry.get_text)
			switch_note(true) if @top.urlview.entry.get_text == ''
		}

		@top.exit.signal_connect('clicked') { quit ; Gtk::main_quit }

		@top.check.signal_connect('toggled') {|w|
			unless @switch
				if @main_note.get_current_page != 0
					@main_note.cur_page.child.bookmark.toggle
					@subjects.bookmark.update
				else
					@tab_lock.toggleStatus
				end
			end
		}

		@top.followup.set_sensitive(false)
		@top.followup.signal_connect('clicked') {
			if defined?(@main_note.cur_page.child.post_open)
				@main_note.cur_page.child.post_open
				set_focus(@main_note.cur_page.child.post.text)
			end
		}

		if CFG::EXT.migemo_flag
			@top.urlview.entry.signal_connect('changed') {
				if @top.urlview.entry.get_text !~ /^http:\/\//
					if @main_note.visible? and @main_note.get_current_page != 0 and @switch == false
						@main_note.cur_page.child.increment(@top.urlview.entry.get_text)
					end
				end
			}
		end

		@top.urlview.entry.signal_connect('activate') {
			u = @top.urlview.entry.get_text
			case u
			when CFG::Regex.uri_2ch
				b = $3 ; d = $4
				b.sub(/(.+?)\/(\d+)/) { b = $1 ; d = $2 } if b =~ /\//
				open_text_frame(b, d.concat('.dat'))
			when CFG::Regex.uri_2ch_board
				board = $1
				switch_board(board, true) if BBSMenu::Servers.include?(board)
			else
				@top.find.clicked
			end
		}

		@top.windmill.signal_connect('button_press_event') {|w, e|
			show_config.popup(nil, nil, nil, e.button, e.time)
		}

		return(@top)
	end

	def board_select
		@board_tree = BoardSelector.new

		@board_tree.child.signal_connect('key_press_event') {|w, e|
			case e.keyval
			when Gdk::GDK_space
				node = ''
				@board_tree.child.each_selection {|n| node = n }
				if @board_tree.child.get_node_info(node)[6]
					select_board(node)
				else
					@board_tree.child.toggle_expansion(node)
				end
			when Gdk::GDK_r
				@s_thr = Thread.fork {
					w = @top.windmill.start('U:BoardMenu')
					if w
						set_focus(@main_note.cur_page.child.child)
						@board_tree.update
						@top.windmill.stop('U:BoardMenu')
					end
				}
			when Gdk::GDK_S then @top.select.clicked
			when Gdk::GDK_q then @top.select.clicked
			end
		}

		@board_tree.child.signal_connect('button_release_event') {|w, e|
			case e.button
			when 1
				node = ''
				@board_tree.child.each_selection {|n| node = n }
				if @board_tree.child.get_node_info(node)[6]
					select_board(node)
				end
			end
		}

		return(@board_tree)
	end

	def subject_frame
		profile = Session::Profile.read(CFG::SYS.root + 'profile')
		if profile
			@subjects = SubjectFrame.new(profile['board'])
		else
			@subjects = SubjectFrame.new(false)
		end

		@subjects.child.signal_connect('button_release_event') {|w, e|
			if @subjects.pop? == false
				select_thread if e.button == 1
			end
		}

		@subjects.child.signal_connect('key_press_event') {|w, e|
			case e.keyval
			when Gdk::GDK_space then select_thread
			when Gdk::GDK_h then @main_note.prev_page ; switch_note(true)
			when Gdk::GDK_l then @main_note.next_page ; switch_note(true)
			when Gdk::GDK_L then @top.check.clicked  # Update tabs Lock
			when Gdk::GDK_b then @top.bookmark.clicked
			when Gdk::GDK_r then @top.reload.clicked
			when Gdk::GDK_c then @top.cancel.clicked
			when Gdk::GDK_S then @top.select.clicked
			when Gdk::GDK_q then @top.exit.clicked
			when Gdk::GDK_p then subject_frame_type_toggle
			when Gdk::GDK_t then subject_frame_hide_toggle
			when Gdk::GDK_slash then focus_find
			when Gdk::GDK_less  # '<'
				@main_note.set_page(0) ; switch_note(true)
			when Gdk::GDK_greater  # '>'
				@main_note.set_page(@thread_chain.size) ; switch_note(true)
			when Gdk::GDK_f 
				@subjects.freeze
				@top.bookmark.active = false
				@subjects.thaw
				@subjects.refresh
			end
		}

		@subjects.child.signal_connect('click_column') {|w, c|
			case c
			when 0
				@subjects.freeze
				@top.bookmark.active = false
				@subjects.thaw
			end
		}

		return(@subjects)
	end

	def favorites_buttons
		num = CFG::UIF.favorite_buttons
		num = 256 if num == 0
		box = Gtk::HBox.new
		favorites = BBSMenu.favorite
		if favorites != []
			num = favorites.size if num > favorites.size
			num.times {|i|
				n, uri = favorites[i]
				b = Gtk::Button.new(n)
				b.signal_connect('clicked') {
					server, board = String2ch.parse_uri(uri)
					switch_board(board, true)
				}
				box.pack_start b

				if i + 1 < 10
					self.signal_connect('key_press_event') {|w, e|
						if e.state == Gdk::CONTROL_MASK
							case e.keyval
							when eval("Gdk::GDK_#{i + 1}") then b.clicked
							end
						end
					}
				end
			}
		end
		return(box)
	end

	def main_note
		@main_note = Gtk::Notebook.new
		@main_note.set_scrollable(true)
		@main_note.append_page(subject_frame, Gtk::Label.new("#{@subjects.board.capitalize}@2ch"))

		@main_note.signal_connect('button_release_event') {|w, e|
			switch_note(true) if e.button != 4 && e.button != 5
		}

		@top.urlview.set_board(@subjects.board)  # not yet. äƤʡ <=  ? (^^;

		return(@main_note)
	end

	def main_pane
		@main_pane = Gtk::HPaned.new
		if CFG::UIF.board_position
			@main_pane.pack1(board_select, false, true)
			@main_pane.pack2(main_note, true, true)
		else
			@main_pane.pack1(main_note, true, true)
			@main_pane.pack2(board_select, false, true)
		end
		@main_pane.set_gutter_size(2)
		@main_pane.set_handle_size(2)
		@main_pane.set_position(CFG::UIF.bs_nonactive)
		@top.select.active = true if CFG::UIF.board_start_open
		return(@main_pane)
	end


	#
	# callback_functions
	#

	def subject_frame_hide_toggle
		if @subjects.filter.abone
			@subjects.filter.abone = false
		else
			@subjects.filter.abone = true
		end
		@subjects.update(false)
	end

	def subject_frame_type_toggle
		@s_thr = Thread.fork {
			w = @top.windmill.start('U:Subject')
			if w
				@subjects.toggle
				@top.windmill.stop('U:Subject')
			end
		}
	end

	def open_text_frame(board, dat, type = 'live', focus = true)
		w = @top.windmill.start('G:'.concat(dat))
		return(false) unless w 

		@t_thr = Thread.fork {
			r = 0
			@subjects.child.each_selection {|s| r = s }
			if @thread_chain.include?(dat)
				select_thread_tab(dat)
				@main_note.cur_page.child.update
			else
				case type
				when 'live'
					x = init_live_text_frame(board, dat, get_url(board, dat, 'live'))
				when 'past'
					x = init_past_text_frame(board, dat, get_url(board, dat, 'past'))
				end
				@main_note.append_page(x[0], x[1])
				@main_note.show_all
				x[0].redraw  # append Ƥ顣
				x[0].adjust

				select_thread_tab(dat) if focus
			end
			if focus
				set_focus(@main_note.cur_page.child.child)
				switch_note(true)
			end
			@subjects.cached(r) if @subjects.board == board
			@top.windmill.stop('G:'.concat(dat))
		}
	end

	def init_text_frame(texts)
		texts.child.signal_connect('key_press_event') {|w, e|
			case e.keyval
			when Gdk::GDK_h then @main_note.prev_page ; switch_note(true)
			when Gdk::GDK_l then @main_note.next_page ; switch_note(true)
			when Gdk::GDK_H then move_tab(texts, true)
			when Gdk::GDK_L then move_tab(texts, false)
			when Gdk::GDK_b then @top.check.toggled ; switch_note(true)
			when Gdk::GDK_q then close_text_frame(texts)
			when Gdk::GDK_slash then focus_find
			when Gdk::GDK_less  # '<'
				@main_note.set_page(0) ; switch_note(true)
			when Gdk::GDK_greater  # '>'
				@main_note.set_page(@thread_chain.size) ; switch_note(true)
			when Gdk::GDK_space
				o = texts.vadj.value
				texts.vadj.set_value(texts.vadj.value + texts.vadj.page_size / 1.1)
				if CFG::UIF.thread_auto_next
					if o == texts.vadj.value
						close_text_frame(texts)
						@main_note.next_page
						switch_note(true)
					end
				end
			end
		}
		texts.child.signal_connect('button_press_event') {|w, e|
			case e.button
			when 2
				do_retry = false  # not yet. 
				if texts.child.get_chars(0, 100).gsub!(/\n.*/m, '') == CFG::NLS.moved_dat_hell.gsub(/\n.*/m, '')
					do_retry = true 
				end
				if texts.child.has_selection?
					target = texts.get_selection
					if target =~ CFG::Regex.uri_2ch and do_retry
						exec_http_ext($2)
					elsif target =~ CFG::Regex.uri_2ch
						b = $3 ; d = $4
						b.sub(/(.+?)\/(\d+)/) { b = $1 ; d = $2 } if b =~ /\//
						open_text_frame(b, d.concat('.dat'))
					elsif target =~ CFG::Regex.uri
						exec_http_ext($2)
					end
				end
			end
		}

		@thread_chain[texts.dat]= texts

		labels = texts.label
		case labels.size
		when 1
		when 2
			texts.close.signal_connect('clicked'){ close_text_frame(texts) }
		else
			texts.close.signal_connect('clicked'){ close_text_frame(texts) }
			texts.prev.signal_connect('clicked'){ move_tab(texts, true) }
			texts.next.signal_connect('clicked'){ move_tab(texts, false) }
		end

		return([texts, labels[0]])
	end

	def init_live_text_frame(board, dat, uri)
		texts = LiveThreadFrame.new(board, dat, uri)
		texts.child.signal_connect('key_press_event') {|w, e|
			case e.keyval
			when Gdk::GDK_r then @top.reload.clicked
			when Gdk::GDK_w then @top.followup.clicked
			when Gdk::GDK_R
				@t_thr = Thread.fork {
					w = @top.windmill.start('U:'.concat(texts.dat))
					if w
						texts.reget
						set_focus(texts.child)
						@top.windmill.stop('U:'.concat(texts.dat))
					end
				}
			end
		}
		init_text_frame(texts)
	end

	def init_past_text_frame(board, dat, uri)
		texts = PastThreadFrame.new(board, dat, uri)
		init_text_frame(texts)
	end

	def close_text_frame(text_frame)
		text_frame.vadj_info.write if text_frame.title !~ /Download failed/  # not yet. Download failed ˡ
		@thread_chain.delete(text_frame.dat)
		if @main_note.cur_page.child == text_frame
			@main_note.remove_page(@main_note.get_current_page)
		else
			tmp = 0
			tmp = @main_note.cur_page.child.dat if @main_note.get_current_page != 0
			select_thread_tab(text_frame.dat)
			@main_note.remove_page(@main_note.get_current_page)
			@main_note.set_page(0)
			select_thread_tab(tmp) if tmp != 0
		end
		switch_note(true)
	end

	def exec_http_ext(target)
		target.gsub!(/^t+p/, 'http')
		system("#{CFG::EXT.http_cmd.sub(/%d/, target)}")
	end

	def switch_note(focus = false)
		@switch = true
		cur = @main_note.cur_page.child
			if @main_note.get_current_page == 0
				GtkExt.set_tooltip(@top.check, CFG::NLS.ttg_check)
				if @top.check.active? != @tab_lock.active?
					@top.check.active = @tab_lock.active?
				end
				set_title(CiTitleString)
				@main_note.set_tab_label_text(cur, "#{cur.board.capitalize}@2ch")
				@top.bookmark.set_sensitive(true)
				@top.followup.set_sensitive(false)
				if focus
					set_focus(@subjects.child)
					@top.urlview.set_board(@subjects.board)
				end
				@top.urlview.entry.set_text("http://#{BBSMenu::Servers[cur.board]}/#{cur.board}/")
			elsif focus
				if cur.bookmark.is_included?
					@top.check.active = true
				else
					@top.check.active = false
				end
				GtkExt.set_tooltip(@top.check, CFG::NLS.ttg_check_bookmark)
				@top.urlview.set_board(@main_note.cur_page.child.board)
				@top.urlview.entry.set_text(cur.url)
				set_title("#{cur.title} - #{CiShortString}")
				@top.bookmark.set_sensitive(false)
				if cur.mode == 'live'
					@top.followup.set_sensitive(true)
				else
					@top.followup.set_sensitive(false)
				end
				set_focus(@main_note.cur_page.child.child)
			end
		@switch = false
	end

	def switch_board(board, focus = false)
		@s_thr.kill if @s_thr.alive?
		@subjects.rollback
		@top.windmill.stop('G:Subject')
		@top.windmill.stop('U:Subject')
		@subjects.switch(board)
		@s_thr = Thread.fork {
			w = @top.windmill.start('G:Subject')
			if w
				@subjects.update(false)
				@top.windmill.stop('G:Subject')
				@main_note.set_page(0)
				switch_note(focus)
			end
		}
	end

	def select_board(node)  # from BoardMenu.
		server, board = String2ch.parse_uri(@board_tree.child.node_get_row_data(node).uri)
		switch_board(board, false)
		set_focus(@board_tree.child)
	end

	def select_thread  # from SubjectFrame.
		r = 0
		@subjects.child.each_selection {|row| r = row }

		case @top.check.active?
		when true then focus = false
		when false then focus = true
		end

		if @top.windmill.q.include?('G:Subject') #=> ļĤΥ
			open_text_frame(@subjects.past, @subjects.hash[@subjects.child.get_text(r, 0)],
				@subjects.past_mode, focus)
		else #=> ̾
			open_text_frame(@subjects.board, @subjects.hash[@subjects.child.get_text(r, 0)],
				@subjects.mode, focus)
		end
	end

	def select_thread_tab(dat)  # from ThreadFrame.
		@main_note.set_page(0)
		@main_note.next_page
		while @main_note.cur_page.child.dat != dat
			@main_note.next_page
		end
	end

	def move_tab(widget, direction)
		return if @main_note.get_current_page == 1 and direction
		return if @main_note.get_nth_page(1) == widget and direction
		if direction == true  #=> prev
			p = @main_note.get_current_page - 1
		else #=> next
			p = @main_note.get_current_page + 1
		end
		@main_note.reorder_child(widget, p)
	end

	def focus_find
		@top.urlview.entry.set_text('')
		set_focus(@top.urlview.entry)
	end

	def get_url(board = '', dat = '', mode = '')
		case mode
		when 'live'
			uri = "http://#{BBSMenu::Servers[board]}/test/read.cgi/#{board}/#{dat.sub(/\.dat/, '/')}"
		when 'past'
			uri = "file://#{CFG::SYS.root}#{board}/#{BBSBoard::PAST}/#{dat}.#{BBSBoard::CACHE}"
		end
		return(uri)
	end

	def size_allocate
		n = @main_note.get_current_page
		@main_note.set_page(@thread_chain.size)
		while @main_note.get_current_page != 0
			case @main_note.cur_page.child.class.to_s
			when 'LiveThreadFrame'
				@main_note.cur_page.child.redraw if @main_note.cur_page.child.post.clear?
			when 'PastThreadFrame'
				@main_note.cur_page.child.redraw
			end
			@main_note.prev_page
		end
		@main_note.set_page(n)
	end

	def show_config
		pop = GtkExt::ConfigPop.new
		pop.update_bbsmenu.signal_connect('activate'){
			@s_thr = Thread.fork {
				w = @top.windmill.start('U:BoardMenu')
				if w
					GtkExt.parent_window(@main_note).set_focus(@main_note.cur_page.child.child)
					@board_tree.update
					@top.windmill.stop('U:BoardMenu')
				end
			}
		}
		pop.stype.signal_connect('activate'){ subject_frame_type_toggle }
		pop.hide.signal_connect('activate'){ subject_frame_hide_toggle }
		pop.config.signal_connect('activate'){ ConfigWindow.new.show_all }
		pop.about.signal_connect('activate'){ GtkExt::About.new.show_all }
		return(pop)
	end

end


ci = Ci.new
Pix = GtkExt::Pixmap.new(ci, CFG::SYS.siteroot + 'pixmap/')
ci.init
Gtk.main
